Defines | Functions | Variables

# utility.c File Reference

`#include "wizard/studio.h"`
`#include "wizard/exception.h"`
`#include "wizard/exception-private.h"`
`#include "wizard/memory_.h"`
`#include "wizard/resource_.h"`
`#include "wizard/utility.h"`

## Defines
#define | X_OK 1
## Functions
static int | IsDirectory (const char *)
WizardExport void | AppendFileExtension (const char *extension, char *filename)
WizardExport unsigned char * | Base64Decode (const char *source, size_t *length)
WizardExport char * | Base64Encode (const unsigned char *blob, const size_t blob_length, size_t *encode_length)
WizardExport void | ChopPathComponents (char *path, const size_t components)
WizardExport void | GetPathComponent (const char *path, PathType type, char *component)
WizardExport char ** | GetPathComponents (const char *path, size_t *number_components)
WizardExport WizardBooleanType | GetExecutionPath (char *path, const size_t extent)
WizardExport WizardBooleanType | IsAccessible (const char *path)
WizardExport WizardBooleanType | IsWizardTrue (const char *value)
WizardExport const char * | ParseWizardTime (const char *timestamp, time_t *target)
WizardExport FILE * | WizardOpenStream (const char *path, const char *mode)
## Variables
static const char | Base64 [] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"

## Define Documentation

#define X_OK 1

Referenced by IsDirectory().

## Function Documentation

WizardExport void AppendFileExtension | ( | const char * | extension,
|  | char * | filename |
| ) |  |  |

References ConcatenateWizardString(), CopyWizardString(), GetPathComponent(), GetWizardModule, LogWizardEvent(), MaxTextExtent, RootPath, and TraceEvent.

Referenced by AcquireFileLock(), and RelinquishFileLock().

WizardExport unsigned char* Base64Decode | ( | const char * | source,
|  | size_t * | length |
| ) |  |  |

References AcquireQuantumMemory(), Base64, GetWizardModule, LogWizardEvent(), RelinquishWizardMemory(), and TraceEvent.

WizardExport char* Base64Encode | ( | const unsigned char * | blob,
|  | const size_t | blob_length,
|  | size_t * | encode_length |
| ) |  |  |

References AcquireQuantumMemory(), Base64, GetWizardModule, LogWizardEvent(), and TraceEvent.

Referenced by CanonicalXMLContent().

WizardExport void ChopPathComponents | ( | char * | path,
|  | const size_t | components |
| ) |  |  |

References GetPathComponent(), and HeadPath.

Referenced by GetConfigurePaths().

WizardExport WizardBooleanType GetExecutionPath | ( | char * | path,
|  | const size_t | extent |
| ) |  |  |

References AcquireQuantumMemory(), ConcatenateWizardString(), CopyWizardString(), DirectorySeparator, FormatWizardString(), getcwd, getpid, IsAccessible(), MaxTextExtent, NTGetExecutionPath(), PATH_MAX, and RelinquishWizardMemory().

Referenced by WizardsToolkitGenesis().

WizardExport void GetPathComponent | ( | const char * | path,
|  | PathType | type,
|  | char * | component |
| ) |  |  |

References BasePath, CanonicalPath, CopyWizardMemory(), CopyWizardString(), ExtensionPath, FilesystemPath, GetWizardModule, HeadPath, IsAccessible(), IsBasenameSeparator, IsDirectory(), LogWizardEvent(), MaxTextExtent, RootPath, SubnodePath, TailPath, TraceEvent, UndefinedPath, and WizardFalse.

Referenced by AddPathToXMLTree(), AppendFileExtension(), ChopPathComponents(), GetXMLTreePath(), LoadConfigureList(), LoadLogList(), LoadMimeList(), OpenBlob(), and WizardsToolkitGenesis().

WizardExport char** GetPathComponents | ( | const char * | path,
|  | size_t * | number_components |
| ) |  |  |

References AcquireQuantumMemory(), CopyWizardString(), IsBasenameSeparator, MaxTextExtent, ResourceFatalError, and ThrowFatalException.

Referenced by AddPathToXMLTree(), and GetXMLTreePath().

WizardExport WizardBooleanType IsAccessible | ( | const char * | path | ) |

References access, F_OK, S_ISREG, WizardFalse, and WizardTrue.

Referenced by GetExecutionPath(), GetPathComponent(), IsGlob(), and LogWizardEventList().

static int IsDirectory | ( | const char * | path | ) | `[static]`

References access, S_ISDIR, WizardFalse, and X_OK.

Referenced by GetPathComponent().

WizardExport WizardBooleanType IsWizardTrue | ( | const char * | value | ) |

References LocaleCompare(), WizardFalse, and WizardTrue.

Referenced by LoadConfigureList(), and LoadMimeList().

WizardExport const char* ParseWizardTime | ( | const char * | timestamp,
|  | time_t * | target |
| ) |  |  |

References ResetWizardMemory().

WizardExport FILE* WizardOpenStream | ( | const char * | path,
|  | const char * | mode |
| ) |  |  |

References RelinquishWizardMemory().

Referenced by LogWizardEventList(), and OpenBlob().

## Variable Documentation

const char Base64[] = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/"`[static]`

Referenced by Base64Decode(), and Base64Encode().